// ==UserScript==
// @name           test
// @namespace      test
// @description    test
// @include        http://*
// ==/UserScript==

var option = {
	keyword : "",
	favorite_color : "red",
	thumbimg : "2",
	init : function(){
		option.restore("keyword");
		option.restore("favorite_color");
		option.restore("thumbimg");
	},
	restore : function(skey){
		chrome.extension.sendRequest(
			{
				loadStorage : true,
				storage_key : skey
			},
			function(response) {
				option[response.storage_key] = response.storage_value;
			}
		);
	}
};



function keyword_highlight(id){

	var keyword = option["keyword"];
	var color = option["favorite_color"];
	if(!keyword) return;
	if(!color) color = "red";
	
	var elm = document.getElementById(id);
	if(!elm) return;
	if(elm.tagName=="DT"){
		elm = elm.nextSibling;
	}
	
	var str = elm.innerHTML;
	var reg = new RegExp(keyword, "ig");
	str = str.replace(
		reg,
	    function (total) {
	        return "<font color=\""+color+"\"><b>"+total+"</b></font>";
	    }
	);
	elm.innerHTML = str;
}

function link_to_image(id){
	
	var thumbimg = option["thumbimg"];
	if(thumbimg!="1") return;
	
	var elm = document.getElementById(id);
	if(!elm) return;
	if(elm.tagName=="DT"){
		elm = elm.nextSibling;
	}
	
	var imgs = "";
	var str = elm.innerHTML;
	str = str.replace(
	    /h?(ttp:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+(\.png|\.jpg))/g,
	    function (total, url) {
	    	if(url){
	    		imgs += "<img src=\"h"+url+"\" width=\"75\">";
	    	}
	        return total;
	    }
	);
	if(imgs){
		elm.innerHTML += "<br>"+imgs;
	}
}

var obj = {
		autoscroll : true,
		firstreload : true,
		autopage : true,
		range : 0,
		numcount : 0,
		lastmodified: "",
		res0count : 0,
	send: function(event){
		yyRequest("aaa");	
	},
	init: function(event){
		var type = getbbstype();
		if(type=="yy"){
			appendControlDiv();
		}
		if(type=="jbbs"){
			appendControlDiv();
		}
	},
	cancelAutoScroll : function(){
		obj.autoscroll = false;
		var cbx = getElm("gmi_scroll_cbx");
		if(cbx){
			cbx.checked = false;
		}
	},
	onClickWriteFormDisplayCheckBox: function(evt){
		var cbx = getElm("gmi_form_cbx");
		var elms = getTagElms("form");
		if(!cbx || !elms){
			return;
		}
		for ( var i = 0; i < elms.length; i++) {
			var elm = elms[i];
			var act = elm.getAttribute("action");
			if(!act){
				continue;
			}
			if((act.search("/bbs/write.cgi") > -1)||(act.search("/test/bbs.cgi") > -1)){
				if(cbx.checked){
					var oheight = document.body.clientHeight;
					elm.style.display = "block";
					var rheight = document.body.clientHeight;
					window.scrollBy(0, rheight-oheight);
				}else{
					elm.style.display = "none";
				}
				break;
			}
		}
	},
	disp_thread: function(){
		if(obj.res0count>=30){
			obj.reloadEnd();
			return;
		}
		var elm = getElm("timer_disp");
		if(elm){
			if(obj.timer<1){
				//ここで取得
				if(obj.autopage){
					obj.autoLoad();
				}
				if(obj.res0count>5){
					obj.timer = 60;
				}else{
					obj.timer = 30;
				}
			}else{
				obj.timer--;
			}
			var txtNode = document.createTextNode(obj.timer);
			var nodes = elm.childNodes;
			if(nodes && nodes[0]){
				elm.removeChild(nodes[0]);
			}
			elm.appendChild(txtNode);
		}
		obj.timerext = setTimeout("obj.disp_thread()",1000);
	},
	onClickAutoScrollCheckBox: function(evt){
		var cbx = getElm("gmi_scroll_cbx");
		if(cbx){
			if(cbx.checked){
				obj.autoscroll = true;
			}else{
				obj.autoscroll = false;
			}
		}
	},
	onClickAutoReloadCheckBox: function(evt){
		var cbx = getElm("gmi_reload_cbx");
		if(!cbx){
			return;
		}
		if(obj.timerext){
			clearTimeout(obj.timerext);
		}
		if(cbx.checked){
			if(obj.numcount>=1000){
				cbx.checked = false;
			}else{
				if(obj.firstreload){
					setTimeout("obj.autoLoad()",500);
					obj.firstreload = false;
				}
				obj.timer = 30;
				obj.res0count = 0;
				obj.timerext = setTimeout("obj.disp_thread()",1000);
			}
		}
	},
	reloadEnd: function() {
		obj.autopage = false;
		obj.numcount = 1000;
		obj.onClickAutoReloadCheckBox();
	},
	autoLoad: function(){
		if(getbbstype()=="jbbs"){
			var url = jbbsdaturl();
			jbbsRequest(url);
		}
		if(getbbstype()=="yy"){
			var url = yydaturl();
			yyRequest(url);
		}
	}
};

function getbbstype(){
	var win = window;
	if(win.location.href.search("http://yy") > -1 &&
			win.location.href.search("kakiko.com/test/read.cgi/") > -1){
		return "yy"; 
	}
	if(win.location.href.search("http://yy") > -1 &&
			win.location.href.search("kg/test/read.cgi/") > -1){
		return "yy"; 
	}
	if(win.location.href.search("http://jbbs.livedoor.jp/bbs/read.cgi/") > -1){
		return "jbbs"; 
	}
	return "";
}

function printObj(obj){
	var s ="";
	for ( var i in obj) {
		s+=i+"="+obj[i]+"\n";
	}
	alert(s);
}

function jbbsAjaxInsert(resText){
	
	if(!document || !window){
		return;
	}
	
	var doc = document;
	var win = window;
	var dls = doc.body.getElementsByTagName("dl");
	
	if(!dls){
		return;
	}
	
	var rcount = 0;
	var lastnum = obj.numcount;
	var lines = resText.replace("\r","").split("\n");
	
	for ( var i = 0; i < lines.length; i++) {
		var line = lines[i];
		var parts = line.split("<>");
		
		if(parts.length<3){
			continue;
		}
		
		if(obj.numcount==0){
			lastnum++;
			continue;
		}
		var name = parts[1];
		var mail = parts[2];
		var date = parts[3];
		var body = parts[4];
		
		var newDT = doc.createElement("dt");
		var newDD = doc.createElement("dd");
		var newBR = doc.createElement("br");
		var newBR2 = doc.createElement("br");
		
		rcount++;
		lastnum++;
		
		dls[0].appendChild(newDT);
		var a = doc.location.pathname;
		a = a.substr(0, a.lastIndexOf("/")+1);
		a += lastnum;
		var id = "gmi_"+lastnum;
		if(getElm(id)){
			getElm(id).removeAttribute("id");
		}
		newDT.setAttribute("id", id);
		newDT.innerHTML = "<a href=\""+a+"\">"+(lastnum) + '</a> ：<a name="' + (lastnum) + '" href="mailto:' +mail + '"><b>' + name + '</b></a>：' + date;
		
		dls[0].appendChild(newDD);
		newDD.innerHTML = body;
		
		keyword_highlight(id);
		link_to_image(id);
		
		newDD.appendChild(newBR);
		newDD.appendChild(newBR2);
		
		if(obj.autoscroll){
			Sroll.scrollTo(getElm(id));
			//win.location.hash = (lastnum);
		}
	}
	
	if(rcount>0){
		obj.res0count = 0;
	}else{
		obj.res0count++;
	}
	
	obj.numcount = lastnum;
		
	if(obj.numcount>=1000){
		obj.reloadEnd();
	}

}

function yyAjaxInsert(resText){
	
	if(!document || !window){
		return;
	}
	
	var doc = document;
	var win = window;
	var dls = getTagElms("dl");
	
	if(!dls){
		return;
	}
	
	var rcount = 0;
	var lastnum = obj.numcount;
	var lines = resText.replace("\r","").split("\n");
	
	for ( var i = 0; i < lines.length; i++) {
		var line = lines[i];
		var parts = line.split("<>");
		
		if(parts.length<3){
			continue;
		}
		
		if(obj.numcount==0){
			lastnum++;
			continue;
		}
		var name = parts[0];
		var mail = parts[1];
		var date = parts[2];
		var body = parts[3];
		
		var newDT = doc.createElement("dt");
		var newDD = doc.createElement("dd");
		var newBR = doc.createElement("br");
		var newBR2 = doc.createElement("br");
		
		rcount++;
		lastnum++;
		
		dls[0].appendChild(newDT);
		var id = "gmi_"+lastnum;
		if(getElm(id)){
			getElm(id).removeAttribute("id");
		}
		newDT.setAttribute("id", id);
		newDT.innerHTML = (lastnum) + ' ：<a name="' + (lastnum) + '" href="mailto:' +mail + '"><b>' + name + '</b></a>：' + date;
		
		dls[0].appendChild(newDD);
		newDD.innerHTML = body;
		
		keyword_highlight(id);
		link_to_image(id);
		
		newDD.appendChild(newBR);
		newDD.appendChild(newBR2);
		
		if(obj.autoscroll){
			Sroll.scrollTo(getElm(id));
			//win.location.hash = (lastnum);
		}
	}
	
	if(rcount>0){
		obj.res0count = 0;
	}else{
		obj.res0count++;
	}
	
	obj.numcount = lastnum;
		
	if(obj.numcount>=1000){
		obj.reloadEnd();
	}

}

function jbbsRequest(daturl){
	var url2;
	if(obj.numcount>0){
		url2 = daturl + (obj.numcount+1) + "-";
	}else{
		url2 = daturl;
	}
	
	chrome.extension.sendRequest(
		{
			mimetype : "text/plain; charset=EUC-JP",
			update : true,
			lastmodified : obj.lastmodified,
			range : obj.range,
			url : url2
		},
		function(response) {
			if(response.status == 200 || response.status == 206){
				jbbsAjaxInsert(response.text);
			}else{
				if(response.status>400){
					alert(response.status+response.text);
				}
			}
		}
	);
}

function yyRequest(daturl){
	chrome.extension.sendRequest(
		{
			mimetype : "text/plain; charset=shift_jis",
			update : true,
			lastmodified : obj.lastmodified,
			range : obj.range,
			url : daturl
		},
		function(response) {
			if(response.status == 200 || response.status == 206){
				obj.lastmodified = response.lastmodified;
				if(response.length){
					obj.range += parseInt(response.length);
					yyAjaxInsert(response.text);
				}
			}else{
				if(response.status == 304){
					obj.res0count++;
				}
				if(response.status>400){
					alert(response.status+response.text);
				}
			}
		}
	);
}

function yydaturl(){
	var win = window;
	//http://yy33.kakiko.com/test/read.cgi/peercast/1264865694/l50
	//http://yy33.kakiko.com/peercast/dat/1264865694.dat;
	var parts = win.location.pathname.split("/");
	var host = win.location.host;
	var board = parts[3];
	var id = parts[4];
	var daturl = "http://"+host+"/"+board+"/dat/"+id+".dat";
	return daturl;
}

function jbbsdaturl(){
	var win = window;
	//http://jbbs.livedoor.jp/bbs/read.cgi/game/32255/1264801878/l50
	var parts = win.location.pathname.split("/");
	var host = win.location.host;
	var category = parts[3];
	var board = parts[4];
	var id = parts[5];
	var daturl = "http://"+host+"/bbs/rawmode.cgi/"+category+"/"+board+"/"+id+"/";
	return daturl;
}

function getElm(id){
	if(document){
		return document.getElementById(id);
	}else{
		return null;
	}
}

function getTagElms(id){
	if(document){
		return document.getElementsByTagName(id);
	}else{
		return null;
	}
}

function appendControlDiv(){
	
	var doc = document;
	
	if(getElm("gmi_ctrl_dvi")!=null) return;
	
	var pbox = doc.createElement("div");
	pbox.style.margin = "3px 0px 3px 0px";
	pbox.style.borderWidth = "0px 0px 0px 5px";
	pbox.style.borderStyle = "solid";
	pbox.style.borderColor  = "#7688df";
	pbox.setAttribute("id", "gmi_ctrl_dvi");
	doc.body.appendChild(pbox);
		
	var box = doc.createElement("div");
	box.style.borderWidth = "1px";
	box.style.borderStyle  = "solid";
	box.style.borderColor  = "#dfdfdf";
	pbox.appendChild(box);

	var textNode = doc.createTextNode(" オートリロード");
	var autoReloadCbx = doc.createElement("input");
	autoReloadCbx.setAttribute("type", "checkbox");
	autoReloadCbx.setAttribute("id", "gmi_reload_cbx");
	box.appendChild(autoReloadCbx);
	box.appendChild(textNode);
	autoReloadCbx.addEventListener("click", obj.onClickAutoReloadCheckBox, false);
	
	var textNode = doc.createTextNode(" オートスクロール");
	var autoScrollCbx = doc.createElement("input");
	autoScrollCbx.setAttribute("type", "checkbox");
	autoScrollCbx.setAttribute("id", "gmi_scroll_cbx");
	box.appendChild(autoScrollCbx);
	box.appendChild(textNode);
	autoScrollCbx.addEventListener("click", obj.onClickAutoScrollCheckBox, false);
	autoScrollCbx.checked = true;
	
	var textNode = doc.createTextNode(" 書き込み表示");
	var formDispCbx = doc.createElement("input");
	formDispCbx.setAttribute("type", "checkbox");
	formDispCbx.setAttribute("id", "gmi_form_cbx");
	box.appendChild(formDispCbx);
	box.appendChild(textNode);
	formDispCbx.addEventListener("click", obj.onClickWriteFormDisplayCheckBox, false);
	formDispCbx.checked = true;
	
	var divElm = doc.createElement("div");
	doc.body.appendChild(divElm);
	divElm.setAttribute("id", "timer_disp");
	divElm.style.position = "fixed";
	divElm.style.left = "0px";
	divElm.style.bottom = "0px";
	
}


function init(){
	
	window.onmousewheel = Sroll.cancelScroll;
	document.onmousewheel = Sroll.cancelScroll;
	
	option.init();
	
	obj.init(null);
	
}

var Sroll = {
		scrollLength : 10,
		scrollTop : 0,
		targetScrollTop : 0,
		speed : 50,
		timer : 0,
		scrolling : 0,
		scrollTo : function( target ){
			if(Sroll.timer){
				window.clearInterval(Sroll.timer);
			}
			var bHeight = document.body.clientHeight;
			Sroll.targetScrollTop = target.offsetTop + target.clientHeight + target.nextSibling.clientHeight - bHeight ;
			Sroll.scrollTop = document.body.scrollTop;
			Sroll.timer = window.setInterval(Sroll.update, Sroll.speed);
			Sroll.scrolling = 1;
		},
		cancelScroll : function(){
			if(Sroll.scrolling){
				if(Sroll.timer){
					window.clearInterval(Sroll.timer);
					Sroll.timer = 0;
				}
				obj.cancelAutoScroll();
				Sroll.scrolling = 0;
			}
		},
		update : function(){
			var top = document.body.scrollTop;
			Sroll.scrollTop+=Math.ceil((Sroll.targetScrollTop-top)*(Sroll.scrollLength/500));
			if(Sroll.targetScrollTop<=Sroll.scrollTop){
				Sroll.scrollTop = Sroll.targetScrollTop;
				Sroll.timer = window.clearInterval(Sroll.timer);
				Sroll.scrolling = 0;
			}
			window.scrollTo(0, Sroll.scrollTop);
		}
};

init();

